package main

import (
	"bufio"
	"fmt"
	"os"
	"sort"
	"strconv"
	"strings"
)

func main() {
  left := []int{};
  right := []int{};
  reader := bufio.NewReader(os.Stdin)

  for {
    raw, _, _ := reader.ReadLine()
    line := string(raw)
    if strings.Trim(line, " ") == "" {
      break
    }

    values := strings.Split(line, "   ")

    l, _ := strconv.Atoi(values[0])
    r, _ := strconv.Atoi(values[1])

    left = append(left, l)
    right = append(right, r)
  }

  ans := part1(&left, &right)

  fmt.Println("", ans)
}

func part1(left *[]int, right *[]int) int {
  sort.Ints(*left);
  sort.Ints(*right);
  sz := len(*left)
  sum := 0

  for i := 0; i < sz; i++ {
    diff := (*left)[i] - (*right)[i]
    if diff < 0 {
      diff = diff * -1
    }
    sum += diff
  }

  return sum;
}
